/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __BASE_SOCKET_H__
#define __BASE_SOCKET_H__

#include <netinet/in.h>
//#include "TConnectedSocket.h"

// forward references
class connected_socket;



class base_socket
{
  public:
    base_socket () : sockfd (0) {}
    ~base_socket ();

    bool create ();
    bool create (int);

    bool listen ();
   
    connected_socket *accept ();
    connected_socket *connect (int, const char *);

    bool close ();

  private:
    int sockfd;
    sockaddr_in address;
};



#endif
