/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CVS_COMMAND_CHECKOUT_H__
#define __CVS_COMMAND_CHECKOUT_H__

#include "cvs-command.h"
#include <sys/stat.h>
#include <fstream>

// forward references
class cvs_directory_entry;



class cvs_command_checkout : public cvs_command
{
  public:
    cvs_command_checkout (const std::string &, const std::string &, cvs_directory_entry &);
//    virtual ~cvs_command_checkout ();

    virtual bool run (cvs_session &);

  private:
    bool send_command (cvs_session &);
    virtual bool process_line (cvs_session &, const std::string &);
    int cvs2sys_attr (const std::string &);
    bool create_directory (const std::string &);

    std::string item_path;
    std::string item_destination;
    cvs_directory_entry &item_entry;
    std::ofstream cache_file;
    struct stat item_stat;
};



#endif
