/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef __FUSE_CALLBACK_H__
#define __FUSE_CALLBACK_H__

#include <fuse.h>



// forward reference
class fuse_base;



class fuse_callback
{
  public:
    static fuse_callback *instance ();
    
    void setbase (fuse_base *);

    static struct fuse_operations oper;

  private:
    fuse_callback ();

    static int getattr (const char *, struct stat *);
    static int readlink (const char *, char *, size_t);
    static int getdir (const char *, fuse_dirh_t, fuse_dirfil_t);
    static int mknod (const char *, mode_t, dev_t);
    static int mkdir (const char *, mode_t);
    static int unlink (const char *);
    static int rmdir (const char *);
    static int symlink (const char *, const char *);
    static int rename (const char *, const char *);
    static int link (const char *, const char *);
    static int chmod (const char *, mode_t);
    static int chown (const char *, uid_t, gid_t);
    static int truncate (const char *, off_t);
    static int utime (const char *, struct utimbuf *);
    static int open (const char *, int);
    static int read (const char *, char *, size_t, off_t);
    static int write (const char *, const char *, size_t, off_t);
    static int statfs (const char *, struct statfs *);
    static int flush (const char *);
    static int release (const char *, int);
    static int fsync (const char *, int);
    static int setxattr (const char *, const char *, const char *, size_t, int);
    static int getxattr (const char *, const char *, char *, size_t);
    static int listxattr (const char *, char *, size_t);
    static int removexattr (const char *, const char *);
    
    static fuse_callback *self;
    static fuse_base *base;
};



#endif
