/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __SYSLOG_STREAMBUF_H__
#define __SYSLOG_STREAMBUF_H__

#include <string>
#ifdef HAVE_STREAMBUF_H
#include <streambuf.h>
#else
#include <streambuf>
#endif

// forward reference
class syslog_file;


class syslog_streambuf : public std::streambuf
{
  public:
    syslog_streambuf (syslog_file &, int level);
    ~syslog_streambuf ();

    void enable () { fEnable = true; }
    void disable () { fEnable = false; }

  protected:
    virtual int overflow (int);

  private:
    syslog_file	&fFile;
    int		fLevel;
    std::string	fLineBuffer;
    bool	fEnable;
};



#endif
