/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __SYSTEM_LOG_H__
#define __SYSTEM_LOG_H__

#include <string>
#include "syslog-stream.h"

// forward reference
class syslog_file;



class system_log
{
  public:
    typedef enum
    {
      Kernel = 0,
      User,
      Mail,
      Daemon,
      Auth,
      Syslog,
      Lpr,
      News,
      Uucp,
      Cron,
      AuthPriv,
      Ftp
    } LogFacility;

    system_log (const std::string &, LogFacility);
    ~system_log ();
  
    static system_log *instance ();
    static system_log *instance (const std::string &, LogFacility);

  private:
    system_log ();

    static syslog_file	*fFile;

  public:
    syslog_stream	emergency;
    syslog_stream	alert;
    syslog_stream	critical;
    syslog_stream	error;
    syslog_stream	warning;
    syslog_stream	notice;
    syslog_stream	info;
    syslog_stream	debug;

  private:
    static system_log	*fInstance;
};



#endif
